#include <stdio.h>
#include <time.h>

#include "NOiD.iDLE.h"

void first(void)
{
	printf ("first function running \n");	
}

void second(void)
{
	printf ("second function running \n");
}

void third(void)
{
	printf ("third function running \n");
}
 int end;
void more(void)
{
	end = 1;
}

void wait ( int seconds )
{
  clock_t endwait;
  endwait = clock () + seconds * CLK_TCK ;
  while (clock() < endwait) {}
}

int main (void)
{
	NOiD_iDLE_LiST *agenda = NOiD_iDLE_createLiST();				//never forget to declare it as NULL

	printf ("no idea idle\n");

	//printf ("create one function 1 sec \n");
		NOiD_iDLE * chat = NOiD_iDLE_create(1.0,&first,agenda);
	//printf ("create second function 3 sec \n");
		NOiD_iDLE * chien = NOiD_iDLE_create(3.0,&second,agenda);
	//printf ("create third function 6 sec \n");
		NOiD_iDLE * porc = NOiD_iDLE_create(6.0,&third,agenda);
	//printf ("create one more\n");
		NOiD_iDLE_create(10.0,&more,agenda);

	end = 0;
	printf ("start engine \n");
	while (end == 0)
	{	float now = (((float)clock())/CLK_TCK)/1000;
		NOiD_iDLE_loop(now,agenda);	}
	printf ("wait a second\n");
	wait(1);

	end = 0;
	printf ("reloop engine 10 second \n");
	while (end == 0)
	{	float now = (((float)clock())/CLK_TCK)/1000;
		NOiD_iDLE_loop(now,agenda);	}
	printf ("total success\n");

/*	printf("destroy one of them\n");
	NOiD_iDLE_destroy(chien,agenda);
	printf("destroy another\n");
	NOiD_iDLE_destroy(chat,agenda);
	printf("destroy another\n");
	NOiD_iDLE_destroy(porc,agenda);*/

	NOiD_iDLE_freeLiST(agenda);

	return 0;

}
